#ifndef _INDICES_H
#define _INDICES_H
#include <string>
#include <iostream>
#include <iomanip>
#include <boost/numeric/ublas/matrix.hpp>
#include <boost/numeric/ublas/vector.hpp>

#include "typesdef.h"

using namespace boost::numeric::ublas;

namespace indices {
    void calculation( const std::string&  );
    void extract( matrix<double>&, matrix<double>&, matrix<double>&  );
    void desaturation( matrix<double>& );
    std::string out_fluxes( const std::string& );
    std::string out_indices( const std::string& );
    void result( const matrix< double >&, vector<datum>& );
    void set_counters( const vector<double>&, const vector<double>&, const vector<double>& );
    void set_background( const vector<double>& );
    void set_microexposure( double );
}

namespace std {
    template<class T> std::istringstream& operator>>( std::istringstream& stm, std::vector<T>& x ) {
        T a;
        while( stm >> a ) x.push_back( a );
        return stm;
    }
    template<class T> std::istringstream& operator>>( std::istringstream& stm, boost::numeric::ublas::vector<T>& x ) {
        T a;
        unsigned int i = 0;
        while( i < x.size() && stm >> a   ) x(i++) =  a;
        return stm;
    }
}

namespace std {
    std::ostream& indic( std::ostream& stm );
    std::ostream& operator<<( std::ostream& stm, const datum& m );
}


#endif
