#ifndef _NR_H
#define _NR_H

#include <boost/numeric/ublas/vector.hpp>

namespace ublas = boost::numeric::ublas;
//using namespace boost::numeric::ublas;
namespace nr {
    void  four1( ublas::vector<double>& );
    void  spline( const ublas::vector<double>& x, const ublas::vector<double>& y, double yp1, double ypn, ublas::vector<double>& y2 );
    void  splint( const ublas::vector<double>& xa, const ublas::vector<double>& ya, ublas::vector<double>& y2a, double x, double& y );
}

class Spline {
    ublas::vector<double> sec_deriative;
    ublas::vector<double> xa;
    ublas::vector<double> ya;
    double iy;
public:
    Spline( const ublas::vector<double>& x, const ublas::vector<double>& y, double yp1, double ypn )
        : xa(x), ya(y) {
        sec_deriative.resize( x.size() );
        nr::spline( x, y, yp1, ypn, sec_deriative );
    }
    ~Spline(){};
    double get( double ix ) {
        if( ix > xa(xa.size()-1) ) return 0;
        nr::splint( xa, ya, sec_deriative, ix, iy );
        return iy;
    }
};


#endif
