#ifndef _PARAMETERS_H
#define _PARAMETERS_H
#include <string>
#include <iostream>
#include <iomanip>
#include <boost/numeric/ublas/matrix.hpp>
#include <boost/numeric/ublas/vector.hpp>
#include <coordinates.h>

#include "typesdef.h"
#include "weif.h" 

using namespace boost::numeric::ublas;

//struct Spectral_data {
//    std::string response;
//    std::string weights;
//    std::string spectra;
//    Spectral_data( const std::string& r, const std::string& w, const std::string& s ) : response( r ), weights( w ), spectra( s ) {}
//    void root( const std::string& d ) {
//        response = d + '/' + response;
//        weights  = d + '/' + weights;
//        spectra  = d + '/' + spectra;
//    }
//};

namespace parameters {
    Geo* coordinates();
    double accumtime();
    bool   correction();
    Spectral_data& spectral_data_files();
    bool apertures( vector<double>&, vector<double>& );
    bool counters();
    void init_keys();
    void P_line_parse( const std::string&, const std::string& );
    int comand_line_parse( int, char** );
    template<typename T > T get( const std::string val ){
        T x;
        std::istringstream istr( val );
        istr >> x;
        return x;
    }
    template<typename T, int r > T get( const std::string val ){
        T x(r);
        std::istringstream istr( val );
        istr >> x;
        return x;
    }
}
#endif

