#ifndef _NNLS_SKIN_H
#define _NNLS_SKIN_H

#include <boost/numeric/ublas/matrix.hpp>
#include <boost/numeric/ublas/vector.hpp>
#include <boost/numeric/ublas/symmetric.hpp>

#include "weif.h"

using namespace boost::numeric::ublas;

namespace restoration {
    void covariance( matrix<double>&, vector<double>&, symmetric_matrix< double, upper >& );
    double nnls_solve( const matrix< double >&, matrix< double >&, vector< double >&, vector< double >&, vector< double >& );
    double calcn2( matrix<double>&, double, const Weights& );
    void setzcn2( const vector<double>& );
    std::string out_profile( const std::string& );
    std::string out_residual( const std::string& );
}


#endif
